%global docsch      docbook5/schema
%global schurl      file://%{_datadir}/xml/%{docsch}
%global ctlogopt    --noout --add
%global dtdxml      DTD DocBook XML
%global oasisurl    http://www.oasis-open.org/docbook/xml
%global xmlurl      http://docbook.org/xml

Summary:          Norman Walsh's schemas (DTD, Relax NG, W3C schema) for Docbook 5.X
Name:             docbook5-schemas
Version:          5.1
Release:          4%{?dist}
License:          Freely redistributable without restriction
URL:              http://www.oasis-open.org/docbook/
Source0:          http://www.docbook.org/xml/5.0/docbook-5.0.zip
Source1:          http://www.docbook.org/xml/5.1/docbook-v5.1-os.zip

BuildRequires:    perl-generators unzip libxml2

Requires(post):   libxml2
Requires(postun): libxml2
Requires:         xml-common

Provides:         docbook5-dtd = %{version}-%{release}
Provides:         docbook5-rng = %{version}-%{release}
Provides:         docbook5-sch = %{version}-%{release}
Provides:         docbook5-xsd = %{version}-%{release}

BuildArch: noarch


%description
This package provides a complete rewrite of Docbook in RELAX NG and
not compatible with previous Docbook versions. This package contains
Relax NG , DTD and W3C schema for Docbook 5.X. Syntax of those schemas
is XML-compliant and is developed by the OASIS consortium.

%prep
%setup -c -T 
mkdir 5.0
mkdir 5.1

cd 5.0
unzip %{SOURCE0}
mv docbook-5.0/* .
mv docs/ ../
mv README ../
mv ChangeLog ../
cd ..

cd 5.1
unzip %{SOURCE1}
mv schemas/rng .
mv schemas/sch .
mv schemas/catalog.xml .
mv schemas/docbook.nvdl .
cd ..

%build
CATALOG=docbook-5.xml
%{_bindir}/xmlcatalog --create --noout $CATALOG
for v in 5.0
do
  # DTD
  %{_bindir}/xmlcatalog %{ctlogopt} "public" "-//OASIS//%{dtdxml} ${v}//EN" "%{schurl}/dtd/${v}/docbook.dtd" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "system" "%{oasisurl}/${v}/dtd/docbook.dtd" "%{schurl}/dtd/${v}/docbook.dtd" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "system" "%{xmlurl}/${v}/dtd/docbook.dtd" "%{schurl}/dtd/${v}/docbook.dtd" ${CATALOG}
  # XSD
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/xsd/docbook.xsd" "%{schurl}/xsd/${v}/docbook.xsd" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/xsd/docbook.xsd" "%{schurl}/xsd/${v}/docbook.xsd" ${CATALOG}
  # XSD + XInclude
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/xsd/docbookxi.xsd" "%{schurl}/xsd/${v}/docbookxi.xsd" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/xsd/docbookxi.xsd" "%{schurl}/xsd/${v}/docbookxi.xsd" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/xsd/xi.xsd" "%{schurl}/xsd/${v}/xi.xsd" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/xsd/xi.xsd" "%{schurl}/xsd/${v}/xi.xsd" ${CATALOG}
  # XLink + XML
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/xsd/xlink.xsd" "%{schurl}/xsd/${v}/xlink.xsd" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/xsd/xlink.xsd" "%{schurl}/xsd/${v}/xlink.xsd" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/xsd/xml.xsd" "%{schurl}/xsd/${v}/xml.xsd" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/xsd/xml.xsd" "%{schurl}/xsd/${v}/xml.xsd" ${CATALOG}
done
for v in 5.0 5.1
do
  # RNG
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/rng/docbook.rng" "%{schurl}/rng/${v}/docbook.rng" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/rng/docbook.rng" "%{schurl}/rng/${v}/docbook.rng" ${CATALOG}  # RNG+XInclude
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/rng/docbookxi.rng" "%{schurl}/rng/${v}/docbookxi.rng" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/rng/docbookxi.rng" "%{schurl}/rng/${v}/docbookxi.rng" ${CATALOG}
  # RNC
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/rnc/docbook.rnc" "%{schurl}/rng/${v}/docbook.rnc" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/rng/docbook.rnc" "%{schurl}/rng/${v}/docbook.rnc" ${CATALOG}  # RNC+XInclude
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/rnc/docbookxi.rnc" "%{schurl}/rng/${v}/docbookxi.rnc" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/rng/docbookxi.rnc" "%{schurl}/rng/${v}/docbookxi.rnc" ${CATALOG}
  # Schematron
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/sch/docbook.sch" "%{schurl}/sch/${v}/docbook.sch" ${CATALOG}
  %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/sch/docbook.sch" "%{schurl}/sch/${v}/docbook.sch" ${CATALOG}
done
# ---------------------
# Build XML catalog files for each Schema
for v in 5.0 5.1
do
  for s in rng sch; do
   cat=${v}/${s}/catalog.xml
   %{_bindir}/xmlcatalog --noout --create ${cat}
   case $s in
    sch)
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/${s}/docbook.${s}" "docbook.${s}" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/${s}/docbook.${s}" "docbook.${s}" ${cat}
     ;;
    rng)
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/${s}/docbook.${s}" "docbook.${s}" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/${s}/docbook.${s}" "docbook.${s}" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/${s}/docbookxi.${s}" "docbookxi.${s}" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/${s}/docbookxi.${s}" "docbookxi.${s}" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/${s}/docbook.rnc" "docbook.rnc" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/${s}/docbook.rnc" "docbook.rnc" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/${s}/docbookxi.rnc" "docbookxi.rnc" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/${s}/docbookxi.rnc" "docbookxi.rnc" ${cat}
     ;;
   esac
  done
done
for v in 5.0
do
  for s in dtd xsd; do
   cat=${v}/${s}/catalog.xml
   %{_bindir}/xmlcatalog --noout --create ${cat}
   case $s in
    dtd)
     %{_bindir}/xmlcatalog %{ctlogopt} "public" "-//OASIS//%{dtdxml} ${v}//EN" "docbook.dtd" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "system" "%{oasisurl}/${v}/dtd/docbook.dtd" "docbook.dtd" ${cat}
     ;;
    xsd)
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/${s}/docbook.${s}" "docbook.${s}" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/${s}/docbook.${s}" "docbook.${s}" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/${s}/docbookxi.${s}" "docbookxi.${s}" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/${s}/docbookxi.${s}" "docbookxi.${s}" ${cat}
     # XLink + XML:
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/${s}/xlink.xsd" "xlink.xsd" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/${s}/xlink.xsd" "xlink.xsd" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{xmlurl}/${v}/${s}/xml.xsd" "xml.xsd" ${cat}
     %{_bindir}/xmlcatalog %{ctlogopt} "uri" "%{oasisurl}/${v}/${s}/xml.xsd" "xml.xsd" ${cat}
     ;;
   esac
  done
done

%install
DOCBOOK5DIR=%{buildroot}%{_datadir}/xml/docbook5
for v in 5.0 5.1
do
    mkdir -p ${DOCBOOK5DIR}/schema/rng/$v
    mkdir -p ${DOCBOOK5DIR}/schema/sch/$v
    install -m644 $v/rng/* ${DOCBOOK5DIR}/schema/rng/$v
    install -m644 $v/sch/* ${DOCBOOK5DIR}/schema/sch/$v
done
mkdir -p ${DOCBOOK5DIR}/schema/dtd/5.0
mkdir -p ${DOCBOOK5DIR}/schema/xsd/5.0
install -m644 5.0/dtd/* ${DOCBOOK5DIR}/schema/dtd/5.0
install -m644 5.0/xsd/* ${DOCBOOK5DIR}/schema/xsd/5.0
install -D -m755 %{version}/tools/db4-entities.pl %{buildroot}%{_bindir}/db4-entities.pl
install -D -m644 %{version}/tools/db4-upgrade.xsl ${DOCBOOK5DIR}/stylesheet/upgrade/db4-upgrade.xsl
install -D -m644 docbook-5.xml %{buildroot}%{_sysconfdir}/xml/docbook-5.xml

%post
ROOTCATALOG=%{_sysconfdir}/xml/catalog
if [ -w $ROOTCATALOG ]
then
  for v in 5.0 5.1
  do
      %{_bindir}/xmlcatalog %{ctlogopt} "delegatePublic" "-//OASIS//%{dtdxml} ${v}//EN" "%{schurl}/dtd/${v}/catalog.xml" $ROOTCATALOG
      %{_bindir}/xmlcatalog %{ctlogopt} "delegateURI" "%{xmlurl}/${v}/rng/"  "%{schurl}/rng/${v}/catalog.xml" $ROOTCATALOG
      %{_bindir}/xmlcatalog %{ctlogopt} "delegateURI" "%{xmlurl}/${v}/sch/"  "%{schurl}/sch/${v}/catalog.xml" $ROOTCATALOG
  done
  %{_bindir}/xmlcatalog %{ctlogopt} "delegateURI" "%{xmlurl}/5.0/xsd/"  "%{schurl}/xsd/${v}/catalog.xml" $ROOTCATALOG
  %{_bindir}/xmlcatalog %{ctlogopt} "delegateSystem" "%{xmlurl}/5.0/dtd/" "%{schurl}/dtd/${v}/catalog.xml" $ROOTCATALOG
  %{_bindir}/xmlcatalog %{ctlogopt} "delegateURI" "%{xmlurl}/5.0/dtd/" "%{schurl}/dtd/${v}/catalog.xml" $ROOTCATALOG

fi

%postun
if [ "$1" = 0 ]; then
  ROOTCATALOG=%{_sysconfdir}/xml/catalog
  if [ -w $ROOTCATALOG ]
  then
    for v in 5.0 5.1
    do
       %{_bindir}/xmlcatalog --noout --del "%{schurl}/rng/${v}/catalog.xml" $ROOTCATALOG
       %{_bindir}/xmlcatalog --noout --del "%{schurl}/sch/${v}/catalog.xml" $ROOTCATALOG
    done
    %{_bindir}/xmlcatalog --noout --del "%{schurl}/dtd/5.0/catalog.xml" $ROOTCATALOG
    %{_bindir}/xmlcatalog --noout --del "%{schurl}/xsd/5.0/catalog.xml" $ROOTCATALOG
  fi
fi

%files
%doc docs/* README ChangeLog
%config(noreplace) %verify(not md5 size mtime) %{_sysconfdir}/xml/docbook-5.xml
%dir %{_datadir}/xml/docbook5/
%dir %{_datadir}/xml/%{docsch}
%dir %{_datadir}/xml/%{docsch}/dtd
%dir %{_datadir}/xml/%{docsch}/rng
%dir %{_datadir}/xml/%{docsch}/sch
%dir %{_datadir}/xml/%{docsch}/xsd
%dir %{_datadir}/xml/docbook5/stylesheet
%dir %{_datadir}/xml/docbook5/stylesheet/upgrade
%{_datadir}/xml/%{docsch}/dtd/5.0
%{_datadir}/xml/%{docsch}/rng/5.0
%{_datadir}/xml/%{docsch}/sch/5.0
%{_datadir}/xml/%{docsch}/xsd/5.0
%{_datadir}/xml/%{docsch}/rng/%{version}
%{_datadir}/xml/%{docsch}/sch/%{version}
%{_datadir}/xml/docbook5/stylesheet/upgrade/db4-upgrade.xsl
%{_bindir}/db4-entities.pl

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.1-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.1-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.1-2
- Rebuilt for OpenCloudOS Stream 23

* Wed Nov 16 2022 Shuo Wang <abushwang@tencent.com> - 5.1-1
- initial build
